<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="单号" prop="orderId">
        <el-input
          v-model="queryParams.orderId"
          placeholder="请输入单号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="出库单号" prop="listId">
        <el-input
          v-model="queryParams.listId"
          placeholder="请输入出库单号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="物料号" prop="goodsId">
        <el-input
          v-model="queryParams.goodsId"
          placeholder="请输入物料号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="是否锁定" prop="isLock">
        <el-input
          v-model="queryParams.isLock"
          placeholder="请输入是否锁定"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['app:pmsOrderOut:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['app:pmsOrderOut:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['app:pmsOrderOut:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['app:pmsOrderOut:export']"
        >导出</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleImport"
          v-hasPermi="['app:pmsOrderOut:import']"
        >导入</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-remove"
          size="mini"
          @click="handleOut"
        >出库</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-coin"
          size="mini"
          @click="generateWave"
        >生成波次</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="pmsOrderOutList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="记录号" align="center" prop="recordId" /> -->
      <el-table-column label="单号" align="center" prop="orderId" width="270"/>
      <el-table-column label="出库单号" align="center" prop="listId" />
      <el-table-column label="出库单类型" align="center" prop="orderType" >
        <template slot-scope="scope">
          <dict-tag :options="dict.type.out_order_type" :value="scope.row.orderType"/>
        </template>
      </el-table-column>
      <el-table-column label="客户名称" align="center" prop="customerId" />
      <el-table-column label="物料号" align="center" prop="goodsId" />
      <el-table-column label="订单出库数量" align="center" prop="goodsNum" />
      <el-table-column label="总出库数量" align="center" prop="pickNum" />
      <el-table-column label="确认出库数量" align="center" prop="trNum" />
      <el-table-column label="本次出库数量" align="center" prop="shelvesNum" width="200">
        <template slot-scope="scope">
          <el-input-number
            class="item"
            v-model="scope.row.shelvesNum"
            :min="0"
            :max="scope.row.goodsNum"
            :disabled="scope.row.sts == 1"
          ></el-input-number>
        </template>
      </el-table-column>
      <el-table-column label="库存数量" align="center" prop="stockNum" />
      <el-table-column label="物料描述" align="center" prop="goodsDesc" />
      <el-table-column label="订单状态" align="center" prop="orderStatus" >
        
        <template slot-scope="scope">
          <dict-tag :options="dict.type.out_order_status" :value="scope.row.orderStatus"/>
        </template>
      </el-table-column>
      <el-table-column label="生成波次" align="center" prop="generateWave" >
        <template slot-scope="scope">
          <dict-tag :options="dict.type.generate_wave" :value="scope.row.generateWave"/>
        </template>
      </el-table-column>
      <el-table-column label="是否锁定" align="center" prop="isLock" >
        <template slot-scope="scope">
          <dict-tag :options="dict.type.stock_or_order_status" :value="scope.row.isLock"/>
        </template>
      </el-table-column>
      <el-table-column label="操作人" align="center" prop="createBy" />
      <el-table-column label="创建时间" align="center" prop="createTime" />
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改出库单对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
  <el-form ref="form" :model="form" :rules="rules" label-width="80px">
    <el-table  :data="tableData" style="width: 100%">
      <el-table-column label="物料编码" width="280">
        <template slot-scope="scope">
          <el-autocomplete
            :value="queryGoods"
            v-model="scope.row.goodsId"
            :fetch-suggestions="searchGoods"
            :trigger-on-focus="false"
            placeholder="请输入物料编码或名称"
            clearable
            @select="handleMaterialSelect(scope.$index,$event)"
          >
            <template slot-scope="{ item }">
              <div class="material-item">
                <div class="material-code">{{ item.goodsId }}</div>
                <div class="material-divider"></div>
              </div>
            </template>
          </el-autocomplete>
        </template>
      </el-table-column>
      <el-table-column label="物料描述" prop="goodsDesc">
        <template slot-scope="scope">
          <el-input v-model="scope.row.goodsDesc" placeholder="请输入物料描述" />
        </template>
      </el-table-column>
      <el-table-column label="库存数量" prop="stockNum">
        <template slot-scope="scope">
          <el-input v-model="scope.row.stockNum" disabled placeholder="库存数量" />
        </template>
      </el-table-column>
      <el-table-column label="出库数量" prop="goodsNum">
        <template slot-scope="scope">
          <el-input v-model="scope.row.goodsNum" placeholder="请输入出库数量" />
        </template>
      </el-table-column>
    </el-table>
  </el-form>
  <div slot="footer" class="dialog-footer">
    <el-button type="primary" @click="submitForm">确 定</el-button>
    <el-button @click="cancel">取 消</el-button>
  </div>
</el-dialog>
 <!-- 出库弹窗 -->
 <outbound-dialog
      :visible.sync="dialogVisible"
      @submit="handleDialogSubmit"
    />

    <!-- 导入 -->
    <el-dialog :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
      <el-upload ref="upload" :limit="1" accept=".xlsx, .xls" :headers="upload.headers" :action="upload.url" :disabled="upload.isUploading" :on-progress="handleFileUploadProgress"
                 :on-success="handleFileSuccess" :auto-upload="false" drag>
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
        <div class="el-upload__tip text-center" slot="tip">
          <span>仅允许导入xls、xlsx格式文件。</span>
          <el-link type="primary" :underline="false" style="font-size:12px;vertical-align: baseline;" @click="importTemplate">下载模板</el-link>
        </div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFileForm">确 定</el-button>
        <el-button @click="upload.open = false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listPmsOrderOut, getPmsOrderOut, delPmsOrderOut, addPmsOrderOut, updatePmsOrderOut,createOrderOut,updateOrderOut } from "@/api/system/pmsOrderOut";
import {createOutRequestByPmsOrders,createWaveRequestByOrders} from "@/api/system/task";
import OutboundDialog from './components/OutboundDialog'
import {getToken} from "@/utils/auth";
import { queryListByGoodsId } from "@/api/system/stock";
export default {
  name: "PmsOrderOut",
  components: {
    OutboundDialog
  },
  dicts: ["out_order_type", "out_order_status","stock_or_order_status","generate_wave"],
  data() {

    return {
      queryGoods: "",
      upload: {
        open: false,
        title: '上传文件',
        headers: { Authorization: 'Bearer ' + getToken() },
        url: process.env.VUE_APP_BASE_API + '/app/pmsOrderOut/importData', // 确保这里填写正确的上传URL
        isUploading: false
      },
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 出库单表格数据
      pmsOrderOutList: [],
      // 弹出层标题
      title: "",
      dialogVisible: false,
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        orderId: null,
        listId: null,
        goodsId: null,
        orderStatus: null,
        isLock: null
      },
      // 表单参数
      form: {},
      // tableData:[],
      tableData: [
        {
          stockId: Date.now(),
          goodsId: '',
          goodsDesc: '',
          goodsNum: 1,  // 统一使用 goodsNum
          remainNum: 0
        }
      ],
      // 表单校验
      rules: {
        recordId: [
          { required: true, message: "记录号不能为空", trigger: "blur" }
        ],
        orderId: [
          { required: true, message: "wms订单号不能为空", trigger: "blur" }
        ],
        listId: [
          { required: true, message: "出库单号不能为空", trigger: "blur" }
        ],
        goodsId: [
          { required: true, message: "物料号不能为空", trigger: "blur" }
        ],
        goodsNum: [
          { required: true, message: "订单出库数量不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
      /** 新增按钮操作 */
      handleAdd() {
      this.dialogVisible = true
    },

    /** 查询出库单列表 */
    getList() {
      this.loading = true;
      listPmsOrderOut(this.queryParams).then(response => {
        this.pmsOrderOutList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        recordId: null,
        orderId: null,
        listId: null,
        orderType: null,
        customerId: null,
        goodsId: null,
        goodsNum: null,
        pickNum: null,
        trNum: null,
        shelvesNum: null,
        stockNum: null,
        goodsDesc: null,
        spare1: null,
        spare2: null,
        orderStatus: null,
        isLock: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.recordId)
      selection.forEach((element) => {
        if (element.shelvesNum == undefined || element.shelvesNum == 0) {
          element.shelvesNum = element.goodsNum - element.pickNum;
        }
        if(element.isLock == 1){
          element.sts = 1;
        }
        if(element.goodsNum == element.pickNum){
          element.sts = 1;
          element.shelvesNum = 0;
        }
      });
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    // handleAdd() {
    //   this.reset();
    //   this.open = true;
    //   this.title = "添加出库单";
    // },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const recordId = row.recordId || this.ids
      getPmsOrderOut(recordId).then(response => {
        this.form = response.data;
        this.tableData = [this.form]
        console.log(this.tableData)
        this.open = true;
        this.title = "修改出库单";
      });
    },
    handleDialogSubmit(data){
      let form = [];
      console.log("data",data);
      data.forEach((element) => {
        form.push({
          orderType: 6,
          goodsId: element.goodsId,
          goodsNum: element.goodsNum,
          goodsDesc: element.goodsDesc,
          remainNum: element.remainNum,
          inner: true
        });
      });

      createOrderOut(form).then(response => {
        this.$modal.msgSuccess("出库通知单创建成功");
        this.open = false;
        this.getList();
      });
    },
    /** 提交按钮 */
    submitForm() {


      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.recordId != null) {
            this.form = this.tableData[0]
            console.log(this.form)
            updateOrderOut(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          }
        // else {
        //     addPmsOrderOut(this.form).then(response => {
        //       this.$modal.msgSuccess("新增成功");
        //       this.open = false;
        //       this.getList();
        //     });
        //   }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const recordIds = row.recordId || this.ids;
      this.$modal.confirm('是否确认删除出库单编号为"' + recordIds + '"的数据项？').then(function() {
        return delPmsOrderOut(recordIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    generateWave(row){
      const recordIds = row.recordId || this.ids;
      if (recordIds == "" || recordIds == undefined || recordIds.length == 0) {
        this.$modal.msgError("请选择要出库的通知单列表！");
        return;
      }
      var reqArr = [];
      var error = false;

      for (var j = 0; j < recordIds.length; j++) {
        for (var i = 0; i < this.pmsOrderOutList.length; i++) {
          if (recordIds[j] == this.pmsOrderOutList[i].recordId) {
            if(this.pmsOrderOutList[i].shelvesNum ==0){
              this.$modal.msgError("物料号为" + this.pmsOrderOutList[i].goodsId + "已出库完成！");
              error = true;
              break;
            }
            if(this.pmsOrderOutList[i].generateWave ==1){
              this.$modal.msgError("物料号为" + this.pmsOrderOutList[i].goodsId + "已生成波次！");
              error = true;
              break;
            }

            //生成波次，总出库数量直接等于订单出库数量
            this.pmsOrderOutList[i].pickNum = this.pmsOrderOutList[i].goodsNum;
            reqArr.push(this.pmsOrderOutList[i]);
            break;
          }
        }
      }
      if (error) {
        return;
      }

      this.$modal
        .confirm("请确认是否生成波次？")
        .then(function () {
          return createWaveRequestByOrders(reqArr);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("生成波次成功");
        })
        .catch(() => {
          this.$modal.msgSuccess("生成波次异常");
        });
    },
    handleOut(row){
      const recordIds = row.recordId || this.ids;
      if (recordIds == "" || recordIds == undefined || recordIds.length == 0) {
        this.$modal.msgError("请选择要出库的通知单列表！");
        return;
      }
      var reqArr = [];
      var error = false;

      for (var j = 0; j < recordIds.length; j++) {
        for (var i = 0; i < this.pmsOrderOutList.length; i++) {
          if (recordIds[j] == this.pmsOrderOutList[i].recordId) {
            if(this.pmsOrderOutList[i].shelvesNum ==0){
              this.$modal.msgError("物料号为" + this.pmsOrderOutList[i].goodsId + "已出库完成！");
              error = true;
              break;
            }

            reqArr.push(this.pmsOrderOutList[i]);
            break;
          }
        }
      }
      if (error) {
        return;
      }

      this.$modal
        .confirm("请确认本次出库数量是否正确，是否出库？")
        .then(function () {
          return createOutRequestByPmsOrders(reqArr);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("出库任务创建成功");
        })
        .catch(() => {
          this.$modal.msgSuccess("出库任务创建异常");
        });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('app/pmsOrderOut/export', {
        ...this.queryParams
      }, `pmsOrderOut_${new Date().getTime()}.xlsx`)
    },
    handleImport() {
      this.upload.title = '导入';
      this.upload.open = true;
    },
    /** 下载模板操作 */
    importTemplate() {
      this.download('/app/pmsOrderOut/importTemplate', {}, `app_pmsOrderOut_${new Date().getTime()}.xlsx`);
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(
        "<div style='overflow: auto;overflow-x: hidden;max-height: 70vh;padding: 10px 20px 0;'>" +
        response.msg +
        '</div>',
        '导入结果',
        { dangerouslyUseHTMLString: true },
      );
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    },
    // 搜索物料
    async searchGoods(query, callback) {
      if (query.length < 2) {
        callback([]);
        return;
      }

      const queryParams = {
        goodsId: query
      };
      let mockData = [];
      await queryListByGoodsId(queryParams).then(response => {
        if(response.code === 200){
          console.log(response.data)
          response.data.forEach(item => {
            mockData.push({
              // value: item.goodsId,
              goodsId: item.goodsId,
              goodsDesc: item.goodsDesc
            });
          });
          mockData = response.data;
        }
      });
      callback(mockData);

    },

    // 选择物料后填充物料名称和库存数量
    // 选择物料后，更新  goodsDesc
    handleMaterialSelect(index,item){
      console.log("handleMaterialSelect",index);
      const selectedItem = this.tableData[index];
      console.log("selectedItem",selectedItem);

      this.$set(this.tableData, index, {
        ...selectedItem,
        goodsId: item.goodsId,  // 更新物料编码
        goodsDesc: item.goodsDesc,  // 更新物料描述
        remainNum: item.remainNum,  // 更新库存数量
        goodsNum: item.remainNum
      });
    }
  },


};
</script>
